#include <ocicpp.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <string>
#include <iostream.h>
using namespace std;

int main(int argv,char **argc) {
	db::init();
	Cursor *cur=0;
	Connection *con=0;
	string cell;
	string tns,user,passwd;
	string sql;
	//con=db::connect("rbc","cash","cpaacshs");
	while(1) {
		cout<<">";
		getline(cin,sql);
		try {
			if(sql=="connect") {
				cout << "connect string:";
				getline(cin,tns);
				cout<<"user:";
				getline(cin,user);
				cout<<"password:";
				getline(cin,passwd);
				cout<<"Connecting..."<<endl;
				//delete cur;
				//cout<<"Cursor dropped."<<endl;
				delete con;
				//cout<<"Connection dropped."<<endl;
				//con=db::connect("rbc","cash","cpaacshs");
				con=db::connect(tns.c_str(),user.c_str(),passwd.c_str());
				cout<<"connected."<<endl;
			} else if(sql=="version") {
				version();
			} else if(sql=="exit") {
				//delete cur;
				delete con;
				exit(0);
			} else if(con) {
				cur=con->execQuery(sql.c_str());
				for(int i=0;i<cur->getNCols();i++) {
					printf("|%s(%d)",cur->getColName(i),cur->getColSize(i));
				}
				printf("|\n");
				int nCols=cur->getNCols();
				while(cur->fetch()) {
					for(int i=0;i<nCols;i++) {
						if(NO_ERROR(cur->getStr(i,&cell))) {
							printf("|%s",cell.c_str());
						}
					}
					printf("|\n");
				}
				delete cur;
			}
		} catch(OraError *er) {
			printf("%s",er->error);
		}
	}
}	
	