#ifndef __TABLEHEAD_H_
#define __TABLEHEAD_H_

#include "ocicpp.h"


class TableHead {
private:
	 ub2 attrType;
	 text *attrName;
	 ub4 attrNameLen;
	 ub4 attrSize;
	 ub4 reqType;
public:
	TableHead() {
		attrName=0;
		attrNameLen=0;
	}
	~TableHead() {
		free(attrName);
	}
	void setAttrType(ub2 type) {
		attrType=type;
	}
	void setAttrName(text *name,ub4 len) {
		int i;
		attrName=(text *)calloc(len+1,sizeof(text));
		for(i=0;i<len;i++) {
			attrName[i]=name[i];
		}
		attrName[i]='\0';
	}
	void setAttrSize(ub2 size) {
		attrSize=size;
	}
	void setReqType(ub2 type) {
		reqType=type;
	}
	ub2 getAttrType() {
		return attrType;
	}
	ub2 getAttrSize() {
		return attrSize;
	}
	char *getAttrName() {
		return (char *)attrName;
	}
	ub2 getReqType() {
		return reqType;
	}
};	
		
		
		
		
		
		
		



#endif
