#ifndef __DB_H_
#define __DB_H_

#include "ocicpp.h"
#include "Connection.h" 



class db {
	public:
		static OCIEnv *envhp;//=(OCIEnv *)0;
		static ub4 InitMode;//=0;
		// static Connection *con;
		static void init(ub4 InitMode=OCI_DEFAULT) {
			 (void) OCIInitialize(InitMode, (dvoid *)0, (dvoid * (*)(dvoid *, size_t)) 0,
			                      (dvoid * (*)(dvoid *, dvoid *, size_t))0, (void (*)(dvoid *, dvoid *)) 0 );
			 (void) OCIEnvInit( (OCIEnv **) &db::envhp, OCI_DEFAULT, (size_t) 0,(dvoid **) 0 ); 
		}
		static Connection *connect(const char *tnsname,const char *user,const char *password) {
			return new Connection(db::envhp,tnsname,user,password);
		}
};
#endif